# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from webservice_fdsn.app.v1_1_b.models.base_model_ import Model
from webservice_fdsn.app.v1_1_b import util


class DataSelect(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, starttime: datetime=None, endtime: datetime=None, station: str='.*', channel: str='.*', location: str='.*', nodata: str='404'):  # noqa: E501
        """DataSelect - a model defined in Swagger

        :param starttime: The starttime of this DataSelect.  # noqa: E501
        :type starttime: datetime
        :param endtime: The endtime of this DataSelect.  # noqa: E501
        :type endtime: datetime
        :param station: The station of this DataSelect.  # noqa: E501
        :type station: str
        :param channel: The channel of this DataSelect.  # noqa: E501
        :type channel: str
        :param location: The location of this DataSelect.  # noqa: E501
        :type location: str
        :param nodata: The nodata of this DataSelect.  # noqa: E501
        :type nodata: str
        """
        self.swagger_types = {
            'starttime': datetime,
            'endtime': datetime,
            'station': str,
            'channel': str,
            'location': str,
            'nodata': str
        }

        self.attribute_map = {
            'starttime': 'starttime',
            'endtime': 'endtime',
            'station': 'station',
            'channel': 'channel',
            'location': 'location',
            'nodata': 'nodata'
        }
        self._starttime = starttime
        self._endtime = endtime
        self._station = station
        self._channel = channel
        self._location = location
        self._nodata = nodata

    @classmethod
    def from_dict(cls, dikt) -> 'DataSelect':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The DataSelect of this DataSelect.  # noqa: E501
        :rtype: DataSelect
        """
        return util.deserialize_model(dikt, cls)

    @property
    def starttime(self) -> datetime:
        """Gets the starttime of this DataSelect.

        Limit results to time series samples on or after the specified start time (UTC)  # noqa: E501

        :return: The starttime of this DataSelect.
        :rtype: datetime
        """
        return self._starttime

    @starttime.setter
    def starttime(self, starttime: datetime):
        """Sets the starttime of this DataSelect.

        Limit results to time series samples on or after the specified start time (UTC)  # noqa: E501

        :param starttime: The starttime of this DataSelect.
        :type starttime: datetime
        """
        if starttime is None:
            raise ValueError("Invalid value for `starttime`, must not be `None`")  # noqa: E501

        self._starttime = starttime

    @property
    def endtime(self) -> datetime:
        """Gets the endtime of this DataSelect.

        Limit results to time series samples on or before the specified end time (UTC)  # noqa: E501

        :return: The endtime of this DataSelect.
        :rtype: datetime
        """
        return self._endtime

    @endtime.setter
    def endtime(self, endtime: datetime):
        """Sets the endtime of this DataSelect.

        Limit results to time series samples on or before the specified end time (UTC)  # noqa: E501

        :param endtime: The endtime of this DataSelect.
        :type endtime: datetime
        """

        self._endtime = endtime

    @property
    def station(self) -> str:
        """Gets the station of this DataSelect.

        Select one or more SEED station codes. Multiple codes are comma-separated.  # noqa: E501

        :return: The station of this DataSelect.
        :rtype: str
        """
        return self._station

    @station.setter
    def station(self, station: str):
        """Sets the station of this DataSelect.

        Select one or more SEED station codes. Multiple codes are comma-separated.  # noqa: E501

        :param station: The station of this DataSelect.
        :type station: str
        """
        if station is None:
            raise ValueError("Invalid value for `station`, must not be `None`")  # noqa: E501

        self._station = station

    @property
    def channel(self) -> str:
        """Gets the channel of this DataSelect.

        Select one or more SEED channel codes. Multiple codes are comma-separated.  # noqa: E501

        :return: The channel of this DataSelect.
        :rtype: str
        """
        return self._channel

    @channel.setter
    def channel(self, channel: str):
        """Sets the channel of this DataSelect.

        Select one or more SEED channel codes. Multiple codes are comma-separated.  # noqa: E501

        :param channel: The channel of this DataSelect.
        :type channel: str
        """
        if channel is None:
            raise ValueError("Invalid value for `channel`, must not be `None`")  # noqa: E501

        self._channel = channel

    @property
    def location(self) -> str:
        """Gets the location of this DataSelect.

        Select one or more SEED location identifiers. Multiple identifiers are comma- separated. As a special case \"--\" (two dashes) will be translated to a string of two space characters to match blank location IDs.  # noqa: E501

        :return: The location of this DataSelect.
        :rtype: str
        """
        return self._location

    @location.setter
    def location(self, location: str):
        """Sets the location of this DataSelect.

        Select one or more SEED location identifiers. Multiple identifiers are comma- separated. As a special case \"--\" (two dashes) will be translated to a string of two space characters to match blank location IDs.  # noqa: E501

        :param location: The location of this DataSelect.
        :type location: str
        """
        if location is None:
            raise ValueError("Invalid value for `location`, must not be `None`")  # noqa: E501

        self._location = location

    @property
    def nodata(self) -> str:
        """Gets the nodata of this DataSelect.

        Select status code for \"no data\", either '204' (default) or '404'.  # noqa: E501

        :return: The nodata of this DataSelect.
        :rtype: str
        """
        return self._nodata

    @nodata.setter
    def nodata(self, nodata: str):
        """Sets the nodata of this DataSelect.

        Select status code for \"no data\", either '204' (default) or '404'.  # noqa: E501

        :param nodata: The nodata of this DataSelect.
        :type nodata: str
        """

        self._nodata = nodata
