#   Copyright (c) 2019 Boulder Real Time Technologies, Inc.
#
#   This software module is wholly owned by Boulder Real Time
#   Technologies, Inc. Any use of this software module without
#   express written permission from Boulder Real Time Technologies,
#   Inc. is prohibited.
#
#   Author: Ambli LLC (ambli.ll.company@gmail.com)

from . import service_interfaces


AREA_RECTANGLE_MIN_LATITUDE = "minlatitude"
AREA_RECTANGLE_MAX_LATITUDE = "maxlatitude"
AREA_RECTANGLE_MIN_LONGITUDE = "minlongitude"
AREA_RECTANGLE_MAX_LONGITUDE = "maxlongitude"

AREA_CIRCLE_LATITUDE = "latitude"
AREA_CIRCLE_LONGITUDE = "longitude"
AREA_CIRCLE_MIN_RADIUS = "minradius"
AREA_CIRCLE_MAX_RADIUS = "maxradius"


SERVICE_SPECIFIC_DESCRIPTIONS = \
    {
        AREA_RECTANGLE_MIN_LATITUDE: {
            service_interfaces.EVENT: "Limit to events with a latitude larger than or equal to the specified minimum.",
            service_interfaces.STATION: "Limit to stations with a latitude larger than or equal to the specified "
                                        "minimum."
        },
        AREA_RECTANGLE_MAX_LATITUDE: {
            service_interfaces.EVENT: "Limit to events with a latitude smaller than or equal to the specified maximum.",
            service_interfaces.STATION: "Limit to stations with a latitude smaller than or equal to the specified "
                                        "maximum."
        },
        AREA_RECTANGLE_MIN_LONGITUDE: {
            service_interfaces.EVENT: "Limit to events with a longitude larger than or equal to the specified minimum.",
            service_interfaces.STATION: "Limit to stations with a longitude larger than or equal to the specified "
                                        "minimum."
        },
        AREA_RECTANGLE_MAX_LONGITUDE: {
            service_interfaces.EVENT: "Limit to events with a longitude smaller than or equal to the specified "
                                      "maximum.",
            service_interfaces.STATION: "Limit to stations with a longitude smaller than or equal to the specified "
                                        "maximum."
        },
        AREA_CIRCLE_MIN_RADIUS: {
            service_interfaces.EVENT: "Limit to events within the specified minimum number of degrees from the "
                                      "geographic point defined by the latitude and longitude parameters.",
            service_interfaces.STATION: "Limit results to stations within the specified minimum number of degrees "
                                        "from the geographic point defined by the latitude and longitude parameters."
        },
        AREA_CIRCLE_MAX_RADIUS: {
            service_interfaces.EVENT: "Limit to events within the specified maximum number of degrees from the "
                                      "geographic point defined by the latitude and longitude parameters.",
            service_interfaces.STATION: "Limit results to stations within the specified maximum number of degrees "
                                        "from the geographic point defined by the latitude and longitude parameters."
        },
        AREA_CIRCLE_LATITUDE: {
            service_interfaces.EVENT: "Specify the latitude to be used for a radius search.",
            service_interfaces.STATION: "Specify the latitude to be used for a radius search."
        },
        AREA_CIRCLE_LONGITUDE: {
            service_interfaces.EVENT: "Specify the longitude to the used for a radius search.",
            service_interfaces.STATION: "Specify the longitude to the used for a radius search."
        }
    }